#include "condition_variable.h"

ConditionVariable::ConditionVariable()
{
	pthread_mutex_init(&mutex, NULL);
	pthread_cond_init(&condvar, NULL);
}

ConditionVariable::~ConditionVariable()
{
	pthread_mutex_destroy(&mutex);
	pthread_cond_destroy(&condvar);
}

void
ConditionVariable::wait()
{
	pthread_cond_wait(&condvar, &mutex);
}

void
ConditionVariable::signal()
{
	pthread_cond_signal(&condvar);
}

void
ConditionVariable::broadcast()
{
	pthread_cond_broadcast(&condvar);
}
		
void
ConditionVariable::lock()
{
	pthread_mutex_lock(&mutex);
}

void
ConditionVariable::unlock()
{
	pthread_mutex_unlock(&mutex);
}
