#ifndef FALLING_SNOW_SIMULATION_H_
#define FALLING_SNOW_SIMULATION_H_

#include "configuration.h"
#include "scene_descriptor.h"
#include "wind_field.h"
#include "snowflake_job.h"
#include "advance_snowflakes_job.h"

class FallingSnowSimulation
{
	public:
		FallingSnowSimulation(	Configuration *conf,
								SceneDescriptor *scene, 
								WindField *windField
		);

		~FallingSnowSimulation();

		void collision(Snowflake& sf);
		void updateSnowflakes(SnowflakeJob& job, double time);
		void advance(AdvanceSnowflakesJob& job);

		Snowflake *snowflakes;

	private:
		Configuration *conf;
		SceneDescriptor *scene;
		WindField *windField;

		int nSnowflakes;
};

#endif /* FALLING_SNOW_SIMULATION_H_ */
