#include "framerate_counter.h"

FramerateCounter::FramerateCounter()
{
	p = 0;
	sum = 0;
	memset(buf, 0, FPS_BUFFER_SIZE * sizeof(unsigned int));
}

void
FramerateCounter::add(unsigned int time)
{
	sum += time;
	p++;
	p %= FPS_BUFFER_SIZE;
	sum -= buf[p];
	buf[p] = time;
}

double
FramerateCounter::getFramerate()
{
	if (sum > 0)
		return (1000000.0 * FPS_BUFFER_SIZE) / sum;
	else
		return 0.0;
}

