#include "input_controller.h"

InputController::InputController(Configuration *conf, Camera *camera)
	: conf(conf), camera(camera)
{
	
}

InputController::~InputController() {}

void InputController::handleKeyUp(int key)
{
	switch (key)
	{
		case 'v':
			conf->state.boundaryVelocity *= 0.5;
			break;
		case 'w':
			camera->forward = false;
			break;
		case 's':
			camera->backward = false;
			break;
		case 'a':
			camera->left = false;
			break;
		case 'd':
			camera->right = false;
			break;
		case SDLK_LEFT:
			camera->rotleft = false;
			break;
		case SDLK_RIGHT:
			camera->rotright = false;
			break;
		case SDLK_UP:
			camera->up = false;
			break;
		case SDLK_DOWN:
			camera->down = false;
			break;
	}

}

void InputController::handleKeyDown(int key)
{
	switch (key)
	{
		case '1':
			conf->state.drawWindField = !conf->state.drawWindField;
			break;
		case '2':
			conf->state.drawPressureField = !conf->state.drawPressureField;
			break;
		case '3':
			conf->state.drawWindFieldOutline = !conf->state.drawWindFieldOutline;
			break;
		case SDLK_ESCAPE:
			conf->state.interrupted = true;
			break;
		case 'x':
			conf->state.resetWindField = true;
			break;
		case 'v':
			conf->state.boundaryVelocity *= 2.0;
			break;
		case 'f':
			conf->state.fogEnabled = !conf->state.fogEnabled;
			break;
		case 'q':
			conf->state.interrupted = true;
			break;
		case 'r':
			conf->state.render = !conf->state.render;
			break;
		case 'p':
			conf->state.paused = !conf->state.paused;
			break;
		case 'w':
			camera->forward = true;
			break;
		case 's':
			camera->backward = true;
			break;
		case 'a':
			camera->left = true;
			break;
		case 'd':
			camera->right = true;
			break;
		case SDLK_LEFT:
			camera->rotleft = true;
			break;
		case SDLK_RIGHT:
			camera->rotright = true;
			break;
		case SDLK_UP:
			camera->up = true;
			break;
		case SDLK_DOWN:
			camera->down = true;
			break;
	}
}

