#ifndef JOB_H_
#define JOB_H_

#include <string>
#include <iostream>

#define JOB_ADVECT					(1)
#define JOB_BUILD_SOLUTION_VECTOR	(2)
#define JOB_SOLVE_POISSON			(4)
#define JOB_PROJECT					(8)
#define JOB_GENERATE_VORTICITY_CONFINEMENT (16)
#define JOB_ADD_VORTICITY_FORCE		(32)
#define JOB_SNOWFLAKE				(64)
#define JOB_SNOWCOVER				(128)
#define JOB_RENDER					(256)
#define JOB_PREPARE_TIMESTEP		(512)
#define JOB_ADVANCE_SNOWFLAKES		(1024)

#define JOB_STATE_READY				(1)
#define JOB_STATE_RUNNING			(2)
#define JOB_STATE_BLOCKED			(4)

using namespace std;

class Job
{
	public:
		Job();
		virtual ~Job();
		int getType();
		std::string getDescription();
		void print();
	
		int type;
		std::string desc;

		// Queueing system
		int state;             // Ready, running or blocked
		int nParents;          // Number of jobs this job depends on
		int nParentsDone;      // Number of finished dependent jobs 
		int nChildren;         // Number of jobs that depends on this jobs
		Job *preferredSuccessor; // Job to be prioritized when choosing next
		int forcedThread;      // Force execution by specific thread
		Job **children;        // Jobs that depends on this job
};

#endif /* JOB_H_ */
