#ifndef SCENE_DESCRIPTOR_H
#define SCENE_DESCRIPTOR_H

#include "vector3D.h"
#include "mutex.h"
#include "configuration.h"
#include "snowflake.h"
#include "snowcover_job.h"

#include "opengl.h"

#include <stdlib.h>

struct snow_vertex
{
	GLfloat x,y,z;
	GLfloat nx, ny, nz;
	GLfloat r, g, b;
};

class SceneDescriptor {
	friend class SnowSimulator;

	public:
		SceneDescriptor(Configuration *conf);
		~SceneDescriptor();
		void draw();
		void advance();
		void genVertexArray(SnowcoverJob& job);
		void initVertexArray();
		void calcColor(struct snow_vertex& v, float h);

		int nBoxes;
		Box *boxes;
		int *baseIndices;
	
		int vertices;
		struct snow_vertex *vertArray;

		int executing;
		Mutex m;

	private:
		Configuration *conf;
};

#endif
