#include "texture.h"


Texture::Texture(std::string filename)
{
	loadImage(filename.c_str());
	if (!image) {
		std::cout << "Error loading image " << filename << std::endl;
	}
}

Texture::~Texture()
{
	if (image)
		SDL_FreeSurface(image);
}

void
Texture::bind()
{
        glTexImage2D (GL_TEXTURE_2D, 0, 3, image->w,
                  image->h, 0, GL_RGB, GL_UNSIGNED_BYTE,
                  image->pixels);
        glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
                 GL_LINEAR);
        glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
                 GL_LINEAR);

}

void
Texture::loadImage(const char *filename)
{
        SDL_RWops *rwop;

        rwop = SDL_RWFromFile(filename, "rb");
        image = IMG_LoadJPG_RW(rwop);
}

