#ifndef THREAD_H_
#define THREAD_H_

#include <pthread.h>

/*
 * Abstraction class on pthreads
 */
class Thread
{
	public:
		Thread() {};
		virtual ~Thread() {};
		
		/* Creates a thread, starts it and returns immidiately */
		int start();
		
		/* Blocks until the thread exits */
		int join();

	protected:

		/* Override with code to be executed on own thread */
		virtual void run() =0;

	private:
		static void *pthread_entry(void *obj);

		pthread_t tid;
};

#endif /* THREAD_H_ */
