#include "utils.h"

#include <iostream>
using namespace std;

Timer::Timer()
{
	last = time();
}

void
Timer::increment()
{
	last = now;
	now = time();
}

unsigned long long
Timer::time()
{
#ifdef WIN32
	return SDL_GetTicks() * 1000;
#else
	gettimeofday(&temp, NULL);
	return temp.tv_sec * 1000000L + temp.tv_usec;
#endif
}

double
Timer::ddelta()
{
	return double(now - last) / 1000000;
}

unsigned long long
Timer::idelta()
{
	return now - last;
}

void
divideAmongThreads(int threadId, int threads, int n, int& from, int& to)
{
	if (n % threads == 0)
	{
		from = threadId * n / threads;
		to = from + n / threads;
	} else
	{
		double frac = (double) n / threads;
		int bigSlice = (int) ceil(frac);
		int smallSlice = (int) floor(frac);
		int remainder = n % threads;
		
		if (threadId < remainder)
		{
			from = bigSlice * threadId;
			to = from + bigSlice;
		} else 
		{
			from = bigSlice * remainder + smallSlice * (threadId - remainder);
			to = from + smallSlice;
		}
	}
}
