#ifndef VECTOR_3D_H_
#define VECTOR_3D_H_

class Vector3D
{
	public:
		float x, y, z;

		Vector3D();
		Vector3D(float x, float y, float z);
		Vector3D& operator= (Vector3D v);
		Vector3D operator+ (Vector3D v);
	   	Vector3D operator- (Vector3D v);
		Vector3D operator+ (float val);
	   	Vector3D operator- (float val);
		Vector3D operator* (float val);
		Vector3D operator/ (float val);
		Vector3D& operator+= (Vector3D v);
		Vector3D& operator+= (float val);
		Vector3D& operator-= (Vector3D val);
		Vector3D& operator-= (float val);
		Vector3D& operator*= (float val);
		Vector3D& operator/= (float val);
		Vector3D operator- ();
		float dot(const Vector3D& v);
		Vector3D cross(const Vector3D& v);
		float length();
		Vector3D unit();
		void normalize();
};

#endif /* VECTOR_3D_H */
